#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire3200one4xi.py">
#<abstract4xi abstract = "fires to direction one and to distance 3200"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire3200one4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Global constants                            
# ------------------------------------------------------------------------------------------------
#<globalize4xi globalization = "

       
# -------------------------------------------------------------------------------------------------
# SHOT2ONE - COORDINATE SIGNS OF SHOOT2ONE4XI: (X + ,Y + ,Z + )
# -------------------------------------------------------------------------------------------------  

global shot2one32004xi


#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings - copied from load2one4xi.py results to access faster by verb4xi.py
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = False 

                          
# -------------------------------------------------------------------------------------------------
# 3200
# -------------------------------------------------------------------------------------------------                                          
shot2one32004xi = {
                  1:'0x0y3199z',
                  2:'0x2118y2398z',
                  3:'0x96y3198z',
                  4:'1003x1545y2616z',
                  5:'100x78y3197z',
                  6:'1067x1469y2634z',
                  7:'1068x2293y1959z',
                  8:'1091x1968y2274z',
                  9:'109x2091y2419z',
                  10:'1118x2523y1619z',
                  11:'1122x2667y1365z',
                  12:'1126x1391y2652z',
                  13:'1177x2217y1984z',
                  14:'1179x1310y2670z',
                  15:'1180x1889y2296z',
                  16:'120x104y3196z',
                  17:'1227x1227y2687z',
                  18:'1241x2446y1647z',
                  19:'1254x2592y1394z',
                  20:'1264x1806y2319z',
                  21:'1270x1143y2705z',
                  22:'1281x2135y2009z',
                  23:'1307x1058y2722z',
                  24:'1339x972y2738z',
                  25:'1343x1719y2341z',
                  26:'1359x2363y1674z',
                  27:'1380x2048y2034z',
                  28:'1381x2511y1422z',
                  29:'138x133y3194z',
                  30:'1415x1628y2362z',
                  31:'145x2862y1422z',
                  32:'1472x2275y1701z',
                  33:'1473x1957y2058z',
                  34:'1482x1535y2384z',
                  35:'14x382y3176z',
                  36:'1503x2423y1451z',
                  37:'152x163y3192z',
                  38:'1543x1439y2405z',
                  39:'1560x1861y2083z',
                  40:'1579x2181y1728z',
                  41:'1598x1341y2426z',
                  42:'1619x2329y1479z',
                  43:'1641x1761y2107z',
                  44:'1646x1240y2447z',
                  45:'164x195y3189z',
                  46:'1680x2081y1755z',
                  47:'1689x1139y2467z',
                  48:'1716x1658y2131z',
                  49:'1730x2229y1508z',
                  50:'173x229y3187z',
                  51:'1775x1977y1782z',
                  52:'1784x1552y2155z',
                  53:'178x264y3184z',
                  54:'180x338y3176z',
                  55:'181x300y3180z',
                  56:'181x387y3272z',
                  57:'1834x2124y1536z',
                  58:'1846x1443y2178z',
                  59:'184x2654y1777z',
                  60:'1863x1869y1808z',
                  61:'18x26y3199z',
                  62:'1901x1332y2202z',
                  63:'1932x2014y1564z',
                  64:'1945x1757y1834z',
                  65:'2020x1641y1861z',
                  66:'2023x1899y1592z',
                  67:'2088x1522y1887z',
                  68:'2108x1780y1619z',
                  69:'211x2416y2087z',
                  70:'216x2058y2440z',
                  71:'2185x1658y1647z',
                  72:'249x2960y1189z',
                  73:'293x2836y1451z',
                  74:'31x349y3180z',
                  75:'320x2020y2460z',
                  76:'320x2623y1804z',
                  77:'334x2381y2111z',
                  78:'34x54y3199z',
                  79:'3x32y3199z',
                  80:'3x64y3199z',
                  81:'402x2931y1218z',
                  82:'420x1976y2480z',
                  83:'439x2803y1479z',
                  84:'454x2339y2135z',
                  85:'454x2585y1830z',
                  86:'45x2678y1750z',
                  87:'45x316y3184z',
                  88:'46x83y3198z',
                  89:'516x1928y2501z',
                  90:'552x2894y1248z',
                  91:'55x282y3187z',
                  92:'56x114y3197z',
                  93:'571x2291y2159z',
                  94:'582x2761y1507z',
                  95:'584x2539y1856z',
                  96:'609x1874y2520z',
                  97:'62x147y3195z',
                  98:'62x247y3189z',
                  99:'66x180y3194z',
                  100:'66x213y3192z',
                  101:'684x2237y2182z',
                  102:'697x1816y2540z',
                  103:'700x2848y1277z',
                  104:'711x2487y1882z',
                  105:'722x2712y1536z',
                  106:'781x1754y2559z',
                  107:'792x2178y2205z',
                  108:'835x2429y1908z',
                  109:'844x2795y1307z',
                  110:'858x2656y1564z',
                  111:'85x2444y2063z',
                  112:'860x1688y2578z',
                  113:'897x2113y2229z',
                  114:'934x1618y2597z',
                  115:'94x2981y1159z',
                  116:'953x2364y1933z',
                  117:'985x2735y1336z',
                  118:'990x2593y1591z',
                  119:'996x2043y2251z'} 

#"
#"/>
    

# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire3200one4xi" usage = "target function for chargeone4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire3200one4xi(queue2one, consumer_channel2one, publisher_channel2one):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE3200ONE4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE3200ONE4XI -  QUEUE2ONE: ", queue2one)      
        #  
        
        print("\n (STEP 1A3/33) OF FIRE3200ONE4XI -  CONSUMER_CHANNEL2ONE: ", consumer_channel2one)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE3200ONE4XI -  PUBLISHER_CHANNEL2ONE: ", publisher_channel2one)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE3200ONE4XI - TRYING TO RETURN BY PUTTING SHOT2ONE32004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2one.put(shot2one32004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE3200ONE4XI - SUCCEEDED TO PUT SHOT2ONE32004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
            # SUCCEEDED TO PUT SHOT2ONE32004XI TO QUEUE2ONE:  <queue4xi.Queue4Xi object at 0x02AF7090>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE3200ONE4XI *** FAILED TO PUT SHOT2ONE32004XI TO QUEUE2ONE: ", queue2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE3200ONE4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi())
        #
         
    if ack2put is True:
        message2send4one = "<ack2put4xi>queue2one8shot2one32004xi</ack2put4xi>"
    else:
        message2send4one = "<nack2put4xi>queue2one8shot2one32004xi</nack2put4xi>" 
            
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
         
        publisher_channel2one.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE3200ONE4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
            # SENT MESSAGE2SEND4ONE:  <ack2put4xi>queue2one8shot2one32004xi</ack2put4xi>  TO PUBLISHER_CHANNEL2ONE:  <read-write PipeConnection, handle 260>  - TIME:  23:45:06 08/24/10 Pacific Daylight Time
        
    except:
        print(" (STEP 3C/33) OF FIRE3200ONE4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2ONE: ", publisher_channel2one, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE3200ONE4XI - RETURNING QUEUE OBJECT QUEUE2ONE: ", queue2one, " - TIME: ", time4xi())  
        # 
            
    return queue2one    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>



# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>
 

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire3200one4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
